* [PATCH] scripts: Add rpm2cpio.sh
@ 2019-01-07 6:04 Jan Kiszka
2019-01-07 13:17 ` Henning Schild
0 siblings, 1 reply; 3+ messages in thread
From: Jan Kiszka @ 2019-01-07 6:04 UTC (permalink / raw)
To: isar-users
From: Jan Kiszka <jan.kiszka@siemens.com>
Bitbake is able to unpack rpm packages. For this to work, it just needs
rpm2cpio.sh in scripts. Add it from rpm upstream, similar to what OE
core did.
Signed-off-by: Jan Kiszka <jan.kiszka@siemens.com>
---
scripts/rpm2cpio.sh | 59 +++++++++++++++++++++++++++++++++++++++++++++++++++++
1 file changed, 59 insertions(+)
create mode 100755 scripts/rpm2cpio.sh
diff --git a/scripts/rpm2cpio.sh b/scripts/rpm2cpio.sh
new file mode 100755
index 0000000..db3cae6
--- /dev/null
+++ b/scripts/rpm2cpio.sh
@@ -0,0 +1,59 @@
+#!/bin/sh -efu
+#
+# This software is a part of ISAR,
+# originating from the RPM Package Manager version 4.14
+#
+# SPDX-License-Identifier: GPL-2.0
+
+fatal() {
+ echo "$*" >&2
+ exit 1
+}
+
+pkg="$1"
+[ -n "$pkg" -a -e "$pkg" ] ||
+ fatal "No package supplied"
+
+_dd() {
+ local o="$1"; shift
+ dd if="$pkg" skip="$o" iflag=skip_bytes status=none $*
+}
+
+calcsize() {
+ offset=$(($1 + 8))
+
+ local i b b0 b1 b2 b3 b4 b5 b6 b7
+
+ i=0
+ while [ $i -lt 8 ]; do
+ b="$(_dd $(($offset + $i)) bs=1 count=1)"
+ [ -z "$b" ] &&
+ b="0" ||
+ b="$(exec printf '%u\n' "'$b")"
+ eval "b$i=\$b"
+ i=$(($i + 1))
+ done
+
+ rsize=$((8 + ((($b0 << 24) + ($b1 << 16) + ($b2 << 8) + $b3) << 4) + ($b4 << 24) + ($b5 << 16) + ($b6 << 8) + $b7))
+ offset=$(($offset + $rsize))
+}
+
+case "$(_dd 0 bs=8 count=1)" in
+ "$(printf '\355\253\356\333')"*) ;; # '\xed\xab\xee\xdb'
+ *) fatal "File doesn't look like rpm: $pkg" ;;
+esac
+
+calcsize 96
+sigsize=$rsize
+
+calcsize $(($offset + (8 - ($sigsize % 8)) % 8))
+hdrsize=$rsize
+
+case "$(_dd $offset bs=3 count=1)" in
+ "$(printf '\102\132')"*) _dd $offset | bunzip2 ;; # '\x42\x5a'
+ "$(printf '\037\213')"*) _dd $offset | gunzip ;; # '\x1f\x8b'
+ "$(printf '\375\067')"*) _dd $offset | xzcat ;; # '\xfd\x37'
+ "$(printf '\135\000')"*) _dd $offset | unlzma ;; # '\x5d\x00'
+ "$(printf '\050\265')"*) _dd $offset | unzstd ;; # '\x28\xb5'
+ *) fatal "Unrecognized rpm file: $pkg" ;;
+esac
--
2.16.4
^ permalink raw reply [flat|nested] 3+ messages in thread
* Re: [PATCH] scripts: Add rpm2cpio.sh
2019-01-07 6:04 [PATCH] scripts: Add rpm2cpio.sh Jan Kiszka
@ 2019-01-07 13:17 ` Henning Schild
2019-01-07 13:17 ` Jan Kiszka
0 siblings, 1 reply; 3+ messages in thread
From: Henning Schild @ 2019-01-07 13:17 UTC (permalink / raw)
To: [ext] Jan Kiszka; +Cc: isar-users
Am Mon, 7 Jan 2019 07:04:03 +0100
schrieb "[ext] Jan Kiszka" <jan.kiszka@siemens.com>:
> From: Jan Kiszka <jan.kiszka@siemens.com>
>
> Bitbake is able to unpack rpm packages. For this to work, it just
> needs rpm2cpio.sh in scripts. Add it from rpm upstream, similar to
> what OE core did.
Could you add where exactly you got that from, and the commit id if it
is version control?
Henning
> Signed-off-by: Jan Kiszka <jan.kiszka@siemens.com>
> ---
> scripts/rpm2cpio.sh | 59
> +++++++++++++++++++++++++++++++++++++++++++++++++++++ 1 file changed,
> 59 insertions(+) create mode 100755 scripts/rpm2cpio.sh
>
> diff --git a/scripts/rpm2cpio.sh b/scripts/rpm2cpio.sh
> new file mode 100755
> index 0000000..db3cae6
> --- /dev/null
> +++ b/scripts/rpm2cpio.sh
> @@ -0,0 +1,59 @@
> +#!/bin/sh -efu
> +#
> +# This software is a part of ISAR,
> +# originating from the RPM Package Manager version 4.14
> +#
> +# SPDX-License-Identifier: GPL-2.0
> +
> +fatal() {
> + echo "$*" >&2
> + exit 1
> +}
> +
> +pkg="$1"
> +[ -n "$pkg" -a -e "$pkg" ] ||
> + fatal "No package supplied"
> +
> +_dd() {
> + local o="$1"; shift
> + dd if="$pkg" skip="$o" iflag=skip_bytes status=none $*
> +}
> +
> +calcsize() {
> + offset=$(($1 + 8))
> +
> + local i b b0 b1 b2 b3 b4 b5 b6 b7
> +
> + i=0
> + while [ $i -lt 8 ]; do
> + b="$(_dd $(($offset + $i)) bs=1 count=1)"
> + [ -z "$b" ] &&
> + b="0" ||
> + b="$(exec printf '%u\n' "'$b")"
> + eval "b$i=\$b"
> + i=$(($i + 1))
> + done
> +
> + rsize=$((8 + ((($b0 << 24) + ($b1 << 16) + ($b2 << 8) + $b3)
> << 4) + ($b4 << 24) + ($b5 << 16) + ($b6 << 8) + $b7))
> + offset=$(($offset + $rsize))
> +}
> +
> +case "$(_dd 0 bs=8 count=1)" in
> + "$(printf '\355\253\356\333')"*) ;; # '\xed\xab\xee\xdb'
> + *) fatal "File doesn't look like rpm: $pkg" ;;
> +esac
> +
> +calcsize 96
> +sigsize=$rsize
> +
> +calcsize $(($offset + (8 - ($sigsize % 8)) % 8))
> +hdrsize=$rsize
> +
> +case "$(_dd $offset bs=3 count=1)" in
> + "$(printf '\102\132')"*) _dd $offset | bunzip2 ;; #
> '\x42\x5a'
> + "$(printf '\037\213')"*) _dd $offset | gunzip ;; #
> '\x1f\x8b'
> + "$(printf '\375\067')"*) _dd $offset | xzcat ;; #
> '\xfd\x37'
> + "$(printf '\135\000')"*) _dd $offset | unlzma ;; #
> '\x5d\x00'
> + "$(printf '\050\265')"*) _dd $offset | unzstd ;; #
> '\x28\xb5'
> + *) fatal "Unrecognized rpm file: $pkg" ;;
> +esac
^ permalink raw reply [flat|nested] 3+ messages in thread
* Re: [PATCH] scripts: Add rpm2cpio.sh
2019-01-07 13:17 ` Henning Schild
@ 2019-01-07 13:17 ` Jan Kiszka
0 siblings, 0 replies; 3+ messages in thread
From: Jan Kiszka @ 2019-01-07 13:17 UTC (permalink / raw)
To: Henning Schild; +Cc: isar-users
On 07.01.19 14:17, Henning Schild wrote:
> Am Mon, 7 Jan 2019 07:04:03 +0100
> schrieb "[ext] Jan Kiszka" <jan.kiszka@siemens.com>:
>
>> From: Jan Kiszka <jan.kiszka@siemens.com>
>>
>> Bitbake is able to unpack rpm packages. For this to work, it just
>> needs rpm2cpio.sh in scripts. Add it from rpm upstream, similar to
>> what OE core did.
>
> Could you add where exactly you got that from, and the commit id if it
> is version control?
See the header of the file.
Jan
>
> Henning
>
>> Signed-off-by: Jan Kiszka <jan.kiszka@siemens.com>
>> ---
>> scripts/rpm2cpio.sh | 59
>> +++++++++++++++++++++++++++++++++++++++++++++++++++++ 1 file changed,
>> 59 insertions(+) create mode 100755 scripts/rpm2cpio.sh
>>
>> diff --git a/scripts/rpm2cpio.sh b/scripts/rpm2cpio.sh
>> new file mode 100755
>> index 0000000..db3cae6
>> --- /dev/null
>> +++ b/scripts/rpm2cpio.sh
>> @@ -0,0 +1,59 @@
>> +#!/bin/sh -efu
>> +#
>> +# This software is a part of ISAR,
>> +# originating from the RPM Package Manager version 4.14
>> +#
>> +# SPDX-License-Identifier: GPL-2.0
>> +
>> +fatal() {
>> + echo "$*" >&2
>> + exit 1
>> +}
>> +
>> +pkg="$1"
>> +[ -n "$pkg" -a -e "$pkg" ] ||
>> + fatal "No package supplied"
>> +
>> +_dd() {
>> + local o="$1"; shift
>> + dd if="$pkg" skip="$o" iflag=skip_bytes status=none $*
>> +}
>> +
>> +calcsize() {
>> + offset=$(($1 + 8))
>> +
>> + local i b b0 b1 b2 b3 b4 b5 b6 b7
>> +
>> + i=0
>> + while [ $i -lt 8 ]; do
>> + b="$(_dd $(($offset + $i)) bs=1 count=1)"
>> + [ -z "$b" ] &&
>> + b="0" ||
>> + b="$(exec printf '%u\n' "'$b")"
>> + eval "b$i=\$b"
>> + i=$(($i + 1))
>> + done
>> +
>> + rsize=$((8 + ((($b0 << 24) + ($b1 << 16) + ($b2 << 8) + $b3)
>> << 4) + ($b4 << 24) + ($b5 << 16) + ($b6 << 8) + $b7))
>> + offset=$(($offset + $rsize))
>> +}
>> +
>> +case "$(_dd 0 bs=8 count=1)" in
>> + "$(printf '\355\253\356\333')"*) ;; # '\xed\xab\xee\xdb'
>> + *) fatal "File doesn't look like rpm: $pkg" ;;
>> +esac
>> +
>> +calcsize 96
>> +sigsize=$rsize
>> +
>> +calcsize $(($offset + (8 - ($sigsize % 8)) % 8))
>> +hdrsize=$rsize
>> +
>> +case "$(_dd $offset bs=3 count=1)" in
>> + "$(printf '\102\132')"*) _dd $offset | bunzip2 ;; #
>> '\x42\x5a'
>> + "$(printf '\037\213')"*) _dd $offset | gunzip ;; #
>> '\x1f\x8b'
>> + "$(printf '\375\067')"*) _dd $offset | xzcat ;; #
>> '\xfd\x37'
>> + "$(printf '\135\000')"*) _dd $offset | unlzma ;; #
>> '\x5d\x00'
>> + "$(printf '\050\265')"*) _dd $offset | unzstd ;; #
>> '\x28\xb5'
>> + *) fatal "Unrecognized rpm file: $pkg" ;;
>> +esac
>
--
Siemens AG, Corporate Technology, CT RDA IOT SES-DE
Corporate Competence Center Embedded Linux
^ permalink raw reply [flat|nested] 3+ messages in thread
end of thread, other threads:[~2019-01-07 13:17 UTC | newest]
Thread overview: 3+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2019-01-07 6:04 [PATCH] scripts: Add rpm2cpio.sh Jan Kiszka
2019-01-07 13:17 ` Henning Schild
2019-01-07 13:17 ` Jan Kiszka
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox